Package ch.qos.logback.core.encoder

# Interface Encoder<E>

Type Parameters:
  `E` - event type

All Superinterfaces:
  `ContextAware`, `LifeCycle`

All Known Implementing Classes:
  `EchoEncoder`, `EncoderBase`, `LayoutWrappingEncoder`, `PatternLayoutEncoder`, `PatternLayoutEncoder`, `PatternLayoutEncoderBase`

public interface Encoder<E> extends ContextAware, LifeCycle
Encoders are responsible for transform an incoming event into a byte array

Since:
  0.9.19
Author:
  Ceki Gülcü, Joern Huxhorn, Maarten Bosteels

## Method Summary

Modifier and Type
Method
Description
`byte[]`
`encode(E event)`
Encode an event as bytes.
`byte[]`
`footerBytes()`
Get footer bytes.
`byte[]`
`headerBytes()`
Get header bytes.

### Methods inherited from interface ch.qos.logback.core.spi.ContextAware

`addError, addError, addInfo, addInfo, addStatus, addWarn, addWarn, getContext, setContext`

### Methods inherited from interface ch.qos.logback.core.spi.LifeCycle

`isStarted, start, stop`

## Method Details

### headerBytes

byte[] headerBytes()
Get header bytes. This method is typically called upon opening of an output stream.

Returns:
  header bytes. Null values are allowed.

### encode

byte[] encode(E event)
Encode an event as bytes.

Parameters:
  `event` -

### footerBytes

byte[] footerBytes()
Get footer bytes. This method is typically called prior to the closing of the stream where events are written.

Returns:
  footer bytes. Null values are allowed.